﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr203_3
{
    struct MyStructA
    {
        // Целочисленное поле:
        public int ch;
        // Конструктор:
        public MyStructA(int n)
        {
            ch = n;
        }
        // Операторный метод:
        static public MyStructB operator+(MyStructA self, MyStructA other)
        {
            return new MyStructB(self.ch, other.ch);
        }
        // Вывод значения:
        public int show()
        {
            return ch;
        }
    }

    struct MyStructB
    {
        // Два целочисленных поля:
        public int ch1;
        public int ch2;
        // Конструктор:
        public MyStructB(int n1, int n2)
        {
            ch1 = n1;
            ch2 = n2;
        }
        // Вывод значения:
        public string show()
        {
            return ch1 + " " + ch2;
        }
        // Метод, возвращающий массив структур:
        public MyStructA[] methodB()
        {
            return new MyStructA[2] {new MyStructA(this.ch1), new MyStructA(this.ch2)};
        }
    }

    class Program
    {
        static void Main()
        {
            // Создание одного экземпляра первой структуры:
            MyStructA A1 = new MyStructA(3);
            // Его вывод:
            Console.WriteLine("Структура A1: " + A1.show());
            // Создание другого экземпляра первой структуры:
            MyStructA A2 = new MyStructA(5);
            // Его вывод:
            Console.WriteLine("Структура A2: " + A2.show());
            // Суммирование двух первых структур:
            MyStructB B = A1 + A2;
            // Вывод полученной второй структуры:
            Console.WriteLine("Структура B: " + B.show());
            // Создание еще одной второй структуры:
            MyStructB B1 = new MyStructB(10, 20);
            // Его вывод:
            Console.WriteLine("Структура B1: " + B1.show());
            // Получение массива структур:
            MyStructA[] A3 = B1.methodB();
            // Вывод элементов массива:
            Console.WriteLine("Структура A3[0]: " + A3[0].show());
            Console.WriteLine("Структура A3[1]: " + A3[1].show());
            // Задержка:
            Console.ReadLine();
        }
    }
}
